<?php
session_start();
//típus ellenőrző függvény
function get_image_extension($filename, $include_dot = true, $shorter_extensions = true)
{
  $image_info = @getimagesize($filename);
  if (!$image_info || empty($image_info[2])) { return false; }
  if (!function_exists('image_type_to_extension')) //ha nem létezik a függvény
  {
    function image_type_to_extensiona ($imagetype, $include_dot = true)
    {
      $extensions = array(1  => 'gif', 2  => 'jpeg', 3  => 'png', 4  => 'swf', 5  => 'psd', 6  => 'bmp', 7  => 'tiff', 8  => 'tiff',
                          9  => 'jpc', 10 => 'jp2', 11 => 'jpf', 12 => 'jb2', 13 => 'swc', 14 => 'aiff', 15 => 'wbmp', 16 => 'xbm',);
      $imagetype = (int)$imagetype;
      if (!$imagetype || !isset($extensions[$imagetype])) { return false; }
      return ($include_dot ? '.' : '') . $extensions[$imagetype];
    }
  }
  $extension = image_type_to_extension($image_info[2], $include_dot);
  if (!$extension) { return false; }
  if ($shorter_extensions) {
    $replacements = array('jpeg' => 'jpg', 'tiff' => 'tif');
    $extension = strtr($extension, $replacements);
  }
  return $extension;
}
//"select opciók beállítás" eljárás
function options($options, $selected = null, $labelIsValue = false)
{
  $html = "";
  settype($selected, "array");
  settype($options, "array");
  foreach ($options as $value=>$label)
  { if (is_array($label))
    { $value = $label[0];
      $label = $label[1]; }
    //"htmlspecialchars" konvertál:  '<' => '&lt;' és '>' => '&gt;' és '&' => '&amp;'
    //Ha "ENT_QUOTES"-t beállítják, akkor:    '"' => '&quot;' és ''' => '&#39;'  is
          //$label = htmlspecialchars($label, ENT_QUOTES, "utf-8");
          //$value = $labelIsValue ? $label : htmlspecialchars($value, ENT_QUOTES, "utf-8");
    $value = $labelIsValue ? $label : $value;
    $html .= '<option value="'.$value.'"';
    if (in_array($value, $selected))
    { $html .= ' selected="selected"'; }
    $html .= ">".$label."</option>";
  }
  if (!$html)
  { $html .= '<option value="0">---</option>';
  }
  return $html;
}
if(!isset($_REQUEST["ftipus"]))
  $_REQUEST["ftipus"] = 2;//1;
//könyvtár tartalom törlése: ha $ido-nél(3600=1óra) van régebbi fájl / ha $oc=1 a könyvtárat is!!
function rmdirr($dirname, $oc=0, $ido)
{ // Ha nem létezik -> false
	if (!file_exists($dirname))
  { return false; }
	// Ha fájl és időn túli -> törlés
	if ( (is_file($dirname)) && ((time()-filemtime($dirname)) > $ido) )
	{ return unlink($dirname); }
	// Ha könyvtár
	if(is_dir($dirname))
	{ $dir = dir($dirname);
	  while (false !== $entry = $dir->read())
    { // Ha a benne levő nem fájl -> rekurzív hívás kimarad és ciklus tovább
	    if ($entry == '.' || $entry == '..')
      { continue;	}
	    // Rekurzív meghívás a talált fájlra
	    rmdirr("$dirname/$entry",$oc,$ido);
	  }
	  $dir->close();
	}
	// Könyvtárt is töröl
	if ($oc === 1)
	{ return rmdir($dirname); }
}
//Az 5 percnél régebbi fájlok törlése
rmdirr('photos/original', 0, 300);
rmdirr('photos/th120', 0, 300);
rmdirr('photos/th580', 0, 300);
rmdirr('created', 0, 60);
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
	<meta http-equiv="content-language" content="hu" />
  <link rel="Shortcut Icon" type="image/x-icon" href="favicon.ico" />
  <title>Proghu Tesztek</title>
<style type="text/css">
/* CSS Document */
body{text-align:center;margin:0;padding:0;}
hr{width:95%;}
</style>
</head>
<body style="width:100%;margin:0;padding:auto;text-align:center;">
  <h1>Szöveg PNG képre</h1>
  <h3>(Létrehozás különböző font-típussal "kép-erőforrás"-ként és mentés "lokális fájl"-ként)</h3>
  <h4>Font típusának módosítása</h4>
  <form method="post" action="" name="form1" enctype="multipart/form-data">
    <select style="width:165px;" id="ftipus" name="ftipus">
    <?php
      $num = ($_REQUEST["ftipus"]) ? intval($_REQUEST["ftipus"]) : 0;
      echo options(array(0 => "Arial", 1 => "Century", 2 => "FranciscoLucas Briosa",
                         3 => "Isabella", 4 => "Gunplay 3D"), $num);
    ?>
    </select>
    <br />
    <input type="submit" name="ujkep" value="Létrehoz" />
  </form>
  <br /><hr style="width:60%;" />
  <?php
    include 'text_png.php';
    //bemenő változók meghatározása
    $optszam = time(); 
    $font_func_path ="";
    $szoveg = "  Ez próba, egy adott szöveg PNG-fájlba írására!  ";
    $fszin = "#C7001B";
    $aszin = "#FF979C";
    $sorok_szama = 2;
    $behuzas = 0;
    //kiválasztástól függően
    $font_tip = isset($_REQUEST["ftipus"]) ? intval($_REQUEST["ftipus"]) : 0;
    $font_meret = 24;
    $font_szam = 80;
    $igazit_hor = "2";  //"0"->balra, "1"->jobbra, "2"->középre
    $sor_koz = 24; //betűtípustól függő, általában a $font_meret fele
    $kep_magas_kor = 0; //betűtípustól függő
    $sor_doles = 0;
    $farnyek =  1; //0 => nincs, 1 => van
    $kep_szeles = 0; //ha nincs megadva automatikus
    $kep_magas = 0; //ha nincs megadva automatikus
    //változók átadása az IFRAME "eroforras.php" fájlnak BEGIN
    $_SESSION['ujkep']['tipus'] = $font_tip;
    $_SESSION['ujkep']['fontpat'] = $font_func_path;
    $_SESSION['ujkep']['szoveg'] = $szoveg;
    $_SESSION['ujkep']['fszin'] = $fszin;
    $_SESSION['ujkep']['aszin'] = $aszin;
    $_SESSION['ujkep']['sorok_szama'] = $sorok_szama;
    $_SESSION['ujkep']['behuzas'] = $behuzas;
    $_SESSION['ujkep']['font_meret'] = $font_meret;
    $_SESSION['ujkep']['font_szam'] = $font_szam;
    $_SESSION['ujkep']['igazit_hor'] = $igazit_hor;
    $_SESSION['ujkep']['sor_koz'] = $sor_koz;
    $_SESSION['ujkep']['kep_magas_kor'] = $kep_magas_kor;
    $_SESSION['ujkep']['sor_doles'] = $sor_doles;
    $_SESSION['ujkep']['farnyek'] = $farnyek;
    $_SESSION['ujkep']['kep_szeles'] = $kep_szeles;
    $_SESSION['ujkep']['kep_magas'] = $kep_magas;
    //változók átadása az IFRAME "eroforras.php" fájlnak END
    //aktuális változók korlátozása
    if ($sorok_szama>1)
    { $sor_doles = 0; }
    if ($sorok_szama<2)
    { $igazit_hor = 0;
      $font_szam = 80;
      $behuzas = 0;
    }
    //A "probafajl.png" fájl létrehozása
    kep_letrehoz($font_func_path, $optszam, $szoveg, $fszin, $aszin, $sorok_szama, $behuzas, $font_tip, $font_meret, $font_szam,
                         $igazit_hor, $sor_koz, $kep_magas_kor, $sor_doles, $farnyek, $kep_szeles, $kep_magas);
  ?>
  <h3>A szövegből létrehozott "kép-erőforrás", megjelenítve egy &lt;iframe&gt;-ben</h3>
  <!-- Az "erőforrás kép" létrehozása és megjelenítése -->
  <iframe  src="eroforras.php" style="width:720px;height:85px;  //width:760px; //height:115px; //text-align:center;">
    <p>Az Ön böngészője nem támogatja a kereteket!</p>
  </iframe>
  <br /><br />
  <hr style="width:60%;" />
  <h3>A "kép-erőforrás"-ból lementett "png-fájl", megjelenítve egy &lt;img&gt;-ben</h3>
  <!-- A "lokális kép" megjelenítése -->
  <img class="font-image" alt="" src="created/<?php echo $optszam; ?>.png"  border="1" />
<br /><br /><hr />



  <h1>Képméretezésnél out of memory(danmail)</h1>
  <h4>Válassz egy "*.jpg" fájlt és töltsd fel!</h4>
<?php
$file1 = '';
$file2 = '';
$belyeg_maxszel = 120;
$belyeg_maxmag = 120;
$maxszel = 640;
$maxmag = 480;
if(isset($_FILES['uploaded']))
{
?>
  <form enctype="multipart/form-data" action="" method="post">
  Fájl: <input name="uploaded" type="file" accept="image/*" />
  <br /><br />
  <input type="submit" value="Feltöltés és átméretezés" />
  </form>
<?php
//csere-tömbök
  $mit   = array (" ", "á", "é", "í" , "ó", "ö", "ő", "ú", "ü", "ű", "Á", "É", "Í" , "Ó", "Ö", "Ő", "Ú", "Ü", "Ű");
  $mire  = array ('-', 'a', 'e', 'i' , 'o', 'o', 'o', 'u', 'u', 'u', 'A', 'E', 'I' , 'O', 'O', 'O', 'U', 'U', 'U');
  $target = "photos/original/".basename(  str_replace($mit, $mire,$_FILES['uploaded']['name'])  ) ;
  $name = str_replace($mit, $mire,$_FILES['uploaded']['name']);
  if(move_uploaded_file($_FILES['uploaded']['tmp_name'],$target))
  {
   if(get_image_extension('photos/original/'.str_replace($mit, $mire,$_FILES['uploaded']['name'])) == false)
   { unlink('photos/original/'.str_replace($mit, $mire,$_FILES['uploaded']['name'])); }
   else
   {
    list($w_src, $h_src, $type) = getimagesize('photos/original/'.$name);
    if ($type === 2)
    {
      $kep = imagecreatefromjpeg("photos/original/".$name);
      $sz = imagesx($kep);
      $m = imagesy($kep);
      //méretarányos bélyegkép
      $aranyw = $belyeg_maxszel / $sz;
      $aranyh = $belyeg_maxmag / $m;
      if($aranyw <= $aranyh)
        $arany  = $aranyw;
      else
        $arany = $aranyh;
      $ujszel_k = ceil($sz * $arany);
      $ujmag_k = ceil($m * $arany);
      $th_120 = imagecreatetruecolor($ujszel_k, $ujmag_k);
      imagecopyresampled($th_120, $kep, 0, 0, 0, 0, $ujszel_k, $ujmag_k, $sz, $m);
      //méretarányos nagykép
      $aranyw = $maxszel / $sz;
      $aranyh = $maxmag / $m;
      if($aranyw <= $aranyh)
        $arany  = $aranyw;
      else
      $arany = $aranyh;
      $ujszel_n = ceil($sz * $arany);
      $ujmag_n = ceil($m * $arany);
      $th_580 = imagecreatetruecolor($ujszel_n, $ujmag_n);
      imagecopyresampled($th_580, $kep, 0, 0, 0, 0, $ujszel_n, $ujmag_n, $sz, $m);
      //mentés, erőforrás felszabadítás
      imagejpeg($th_120, "photos/th120/th_".$name, 90);
      imagejpeg($th_580, "photos/th580/th_".$name, 90);
      imagedestroy($th_120);
      imagedestroy($th_580);
      imagedestroy($kep);
      echo '<br />A "'.$_FILES['uploaded']['name'].'" fájl feltöltve és átméretezés elvégezve.<br />';
      $file1 = "photos/th120/th_".$name;
      $file2 = "photos/th580/th_".$name;
    }
    else
    { echo '<h2 style="color:red;">Nem "JPG" fájl!</h2>'; }
   }
  }
  else
    echo "<br />Hiba a feltöltésben!";
}
else
{
?>
  <form enctype="multipart/form-data" action="" method="post">
  Fájl: <input name="uploaded" type="file" accept="image/*" />
  <br /><br />
  <input type="submit" value="Feltöltés és átméretezés" />
  </form>
<?php
  echo '<h3 style="color:green;">Nem volt feltöltés.</h3>';
}
  echo '<h5 style="color:green;">(Beállított Max-adatok: '.$belyeg_maxszel.'*'.$belyeg_maxmag.'px bélyegkép és '.
       $maxszel.'*'.$maxmag.'px nagykép.)</h5>';
?>
  <h4>Szerver-infók</h4>
<?php
$setting = 'upload_max_filesize';
echo '<h5>(';
echo 'A beállított "'. $setting.': '.ini_get($setting), PHP_EOL;
echo '")</h5>';
$setting1 = 'memory_limit';
echo '<h5>(';
echo 'A beállított "'. $setting1.': '.ini_get($setting1), PHP_EOL;
echo '")</h5>';
$setting2 = 'post_max_size';
echo '<h5>(';
echo 'A beállított "'. $setting2.': '.ini_get($setting2), PHP_EOL;
echo '")</h5>';
if (file_exists($file1))
{
  echo '<h4>A "Bélyeg-kép"</h4>';
  echo '<img src="'.$file1.'" style="margin:0;padding:0;background-color:lightgreen;" alt="" title="Méret:'.
       intval($ujszel_k).'*'.intval($ujmag_k).'px" /><br />';
}
if (file_exists($file2))
{
  echo '<h4>Átméretezett "Kép"</h4>';
  echo '<img src="'.$file2.'" style="margin:0;padding:0;background-color:lightgreen;" alt="" title="Méret:'.
       intval($ujszel_n).'*'.intval($ujmag_n).'px" /><br />';
}
?>
  <h4 style="color:red;">A feltöltött képek 5 perc után automatikusan törlődnek!</h4>
  <hr />
  <h4>A teljes forráskód <a href="pngkep.zip">INNEN</a> tölthető le</h4> 
  <hr />
  <br />
  <br />
</body>
</html>
