<?php
//SZÖVEG-KÉP LÉTREHOZÁST MEGHÍVÓ FÜGGVÉNY  
// @param String  $optszam         : Létrehozott képfájl relatív elérése/neve !!kiterjesztés nélkül!!
// @param String  $optszam         : Létrehozott képfájl relatív elérése/neve !!kiterjesztés nélkül!!
// @param String  $szoveg          : Képpé konvertálandó szöveg           sortörés => sor elejére "&#127;"
// @param array   $fszin           : RGB szín szöveg színnek              pl: #371C00
// @param array   $aszin           : RGB szín árnyék színnek              pl: #C99E65
// @param int     $sorok_szama     : A szöveg egy/több sorban             "0" => egy sor, "1" => több sor 
// @param int     $behuzas         : Jelölt sor behúzás                   "0" <=> "5" space karakter
// @param String  $font_tip        : A szöveg betűtípusának neve          ezen fájlhoz képest "/path/betutipus.ttf"
// @param int     $fsize           : A szöveg betűmérete
// @param int     font_szam        : Karakterek száma egy sorban          max 80 karakter
// @param int     $igazit_hor      : Vízszintes igazítás                  balra=> "0", jobbra=> "1", középre=> "2" 
// @param int     $sor_koz         : Sorok közötti távolság               font-függő és kép magasság korrigálást okoz
// @param int     $kep_magas_kor   : A számolt magasság csökkentő érték
// @param int     $sor_doles       : A szöveg dölésszöge                  -90° 0 +90°
// @param boolean $farnyek         : Árnyék engedélyezés                  nincs árnyék => "0", van árnyék => "1"
// @param int     $kep_szeles      : A kép szélessége
function kep_letrehoz($font_func_path, $optszam, $szoveg, $fszin, $aszin, $sorok_szama, $behuzas, $font_tip, $font_meret, $font_szam,
                      $igazit_hor, $sor_koz, $kep_magas_kor, $sor_doles, $farnyek, $kep_szeles, $kep_magas)
{
  //típus módosítás
  if ($farnyek==1) { $arnyek = true; } else { $arnyek = false; }  //árnyék létrehozás van/nincs
  //szín kódok konvertálása
  $font_szin = html2rgb($fszin);
  $bg_szin = html2rgb($aszin);
  //ÁLLANDÓ BEÁLLÍTÁSI PARAMÉTEREK:
  //font-fájlok sorszám alapján
  $font_fajlok = array("fonts/arial.ttf",
                       "fonts/Century.ttf",
                       "fonts/FLbrsa1.ttf",
                       "fonts/Isabella.ttf",
                       "fonts/gunplay3.ttf"
                       );
  $fontszam = count($font_fajlok);
  if ($font_tip > $fontszam-1)
    $font_tip = 0;
  //kiválasztott font-fájl 
  $font_fajl = '/'.$font_func_path.$font_fajlok[$font_tip]; 
  //BEGIN ha nincs a választott font
  if (file_exists(getcwd().$font_fajl))
  { $font_fajl = $font_fajl; }
  else
  { $font_fajl = '/'.$font_func_path.'/fonts/arial.ttf'; }
  //END ha nincs a választott font
  //KÉP RAJZOLÓ FÜGGVÉNY MEGHÍVÁSA
  $szoveg_kep = (imagettfJustifytext($szoveg, $sorok_szama, $font_fajl, $font_szam, $igazit_hor, $sor_koz,
                                     $kep_szeles, $kep_magas, $kep_magas_kor,
                                     $font_meret, $sor_doles, $font_szin, $bg_szin,
                                     $arnyek, $behuzas));
  //másolás local-fájlba
  $szeles = imagesx($szoveg_kep);
  $magas = imagesy($szoveg_kep);
  $szoveg_kep1 = @imagecreate($szeles, $magas);
  imagecopy($szoveg_kep1, $szoveg_kep, 0, 0, 0, 0, $szeles, $magas);
  imagepng($szoveg_kep1, $font_func_path.'created/'.$optszam.".png");
  //erőforrások felszabadítása
  imagedestroy($szoveg_kep1);
  imagedestroy($szoveg_kep);
  return $font_func_path.'created/'.$optszam.".png";
}

//Hexa -> RGB átalakító
function html2rgb($color)
{
  if ($color[0] == "#")
    $color = substr($color, 1);
  if (strlen($color) == 6)
    list($r, $g, $b) = array($color[0].$color[1],
                             $color[2].$color[3],
                             $color[4].$color[5]);
  elseif (strlen($color) == 3)
    list($r, $g, $b) = array($color[0].$color[0], $color[1].$color[1], $color[2].$color[2]);
  else
    return false;
  $r = hexdec($r); $g = hexdec($g); $b = hexdec($b);
  return array($r, $g, $b);
}

//behúzó-jel karakter cseréje behúzó szóközökre
function charswapping($in_line, $indent)
{ return preg_replace("/\#/", $indent, $in_line); }


//SZÖVEG-KÉP LÉTREHOZÓ FÜGGVÉNY  
// @param String  $text        : Képpé konvertálandó szöveg           sortörés => sor elejére "&#127;"
// @param int     $line_number : A szöveg egy/több sorban             "0" => egy sor, "2" => több sor 
// @param String  $font        : A szöveg betűtípusának neve          ezen fájlhoz képest "/path/betutipus.ttf"
// @param int     font_count   : Karakterek száma egy sorban          max 80 karakter
// @param int     $Justify     : Vízszintes igazítás                  balra=> "0", jobbra=> "1", középre=> "2" 
// @param int     $lead        : Sorok közötti távolság               font-függő és kép magasság korrigálást okoz
// @param int     $W           : A kép szélessége
// @param int     $H           : A kép magassága
// @param int     $Hoffs       : A számolt magasság csökkentő érték
// @param int     $angle       : A szöveg dölésszöge                  -90° 0 +90°
// @param int     $fsize       : A szöveg betűmérete
// @param array   $color       : RGB szín-tömb szöveg színnek         pl: #371C00 => "$akrmi=array(0x37,0x1C,0x00)"
// @param array   $shcolor     : RGB szín-tömb árnyék színnek         pl: #C99E65 => "$akrmi1=array(0xC9,0x9E,0x65)"
// @param boolean $shadow      : Árnyék engedélyezés                  van árnyék => "true"
// @param int     $indent_num  : Jelölt sor behúzás                   "0" <=> "5" space karakter
function imagettfJustifytext($text, $line_number, $font, $font_count, $Justify=2, $lead,
                             $W, $H, $Hoffs,
                             $fsize=12, $angle, $color=array(0x00,0x00,0x00), $shcolor=array(0xFF,0xFF,0xFF),
                             $shadow=false, $indent_num)
{
  //BEGIN behúzó szóköz beállítás
  $indent_count = array(""," ","  ","   ","    ","     ");
  $indent_num = ($indent_num>5)?5:($indent_num<0?1:$indent_num);
  $indent = $indent_count[$indent_num];
  //behúzó-jel karakter cseréje behúzó szóközökre
  $text = charswapping($text,$indent);
  //END  behúzó szóköz beállítás
  //BEGIN font-szám minimum beállítása
  if (($font_count < 1) or ($font_count >80))
  { $font_count = 50; }
  else
  { $font_count = $font_count; }
  //END font-szám minimum beállítása
  //Vízszintes igazítás
  $L_R_C = $Justify;
  //Teljes szöveg befoglaló téglalap kalkuláció
  $_bx = imageTTFBbox($fsize,0,getcwd().$font,$text); 
  //BEGIN sorok számának megállapítása
  $s = preg_split('/[\n\r]+/',$text);  //tömb a soroknak
  $nL = count($s);  //sorok száma
  //END sorok számának megállapítása
  //Sorköz minimum beállítása
  $lead = ($lead<0)?0:$lead; //sorköz nem lehet kisebb 0-nél
  //TruType betűtípusú  1-soros minta-szöveg magasságának lekérdezése(font-függő)
  //BEGIN egy-soros minta-szöveg befoglaló téglalap kalkuláció
  $abc ="ÁRVÍZTŰRŐ árvíztűrő GÁT gát ";       
  $font_minta = imageTTFBbox($fsize,0,getcwd().$font,$abc);
  $font_W=abs($font_minta[2]-$font_minta[0]);
  $font_H=abs($font_minta[5]-$font_minta[3]);
  //END egy-soros minta-szöveg befoglaló téglalap kalkuláció
  //BEGIN dölésszög korlátok beállítása
  if (($angle < -90) or ($angle > 90))
  { $angle = 0; }
  else
  { $angle = $angle; }
  //END dölésszög korlátok beállítása
  //BEGIN képszélesség/képmagasság  (ha beállított akkor az, ha nem akkor kalkulált lesz)
  $W = ($W===0)?abs($_bx[2]-$_bx[0]):$W; //jobb alsó - bal alsó sarok X koordináta
  $H = ($H===0)?abs($_bx[5]-$_bx[3]):$H; //jobb felső - jobb alsó sarok Y koordináta
  //sorok számától függő méretek számitása font-magasság, dölés, magasság-korrigálás alapján
  if ($line_number>1) //több soros
  { $H = $nL * ($font_H+$lead)-$Hoffs;
  }
  else                //egy soros(dönthető)
  { $a1 = sin(deg2rad(abs($angle))) * $W;
    $b1 = cos(deg2rad(abs($angle))) * $H;
    $a2 = sin(deg2rad(abs($angle))) * $H;
    $b2 = cos(deg2rad(abs($angle))) * $W;
    $W = intval($a2+$b2);
    $H =  intval($a1+$b1+($nL * $lead)-(sin(deg2rad(abs($angle))) * $Hoffs) );
  }
  //END képszélesség/képmagasság
  //MEGJELENÍTETT KÉPSZÉLESSÉG KORLÁT
  $W = ($W > 800)?800:$W;
  //BEGIN KÉP LÉTREHOZÁSA global $im;
  $im = @imagecreate($W, $H) or die("Nem lehet inicializálni új GD kép folyamatot!");
  $text_color = imagecolorallocate($im, $color[0], $color[1], $color[2]); 
  $shadow_color = imagecolorallocate($im, $shcolor[0], $shcolor[1], $shcolor[2]); 
  $atlatszo = imagecolorallocatealpha($im, $color[0], $color[1], $color[2], 127);
  imagefilledrectangle($im, 0, 0, $W, $H, $atlatszo);
  //font-kép létrehozás különböző igazítással
  if($L_R_C == 0)
  { //Igazítás balra
    $uj_Y=0;
    foreach($s as $key=>$val)
    { $_b = imageTTFBbox($fsize,  0,  getcwd().$font,   $val);
      //string koordináta meghatározása
      if ($line_number>1) //több soros esetén 
      { //X koordináta
        $_X = $W-$W;
        //Y koordináta
        $_H = abs($_b[5]-$_b[3]);
      }
      else                //egysoros (dönthető) esetén 
      {
        if ($angle<0)          //negatív dölésszög
        { //X koordináta
          $_X = intval($W-$W+(sin(deg2rad(abs($angle))) * $lead));
          //Y koordináta
          $_H = intval($b1); 
        }
        else                   //0 és pozitív dölésszög
        { //X koordináta
          $_X = intval($W-$W+(sin(deg2rad(abs($angle))) * 2 * $lead));
          //Y koordináta
          $_H = intval($b1+$a1);
        }
      }
      $uj_Y += $_H;             
      imageTTFText($im, $fsize, $angle, $_X, $uj_Y, $text_color, getcwd().$font, $val);
      if ($shadow)
      { imageTTFText($im, $fsize, $angle, $_X+1, $uj_Y+1, $shadow_color, getcwd().$font, $val); }      
      $uj_Y += $lead;
    }
  }elseif ($L_R_C == 1)
  { //Igazítás jobbra
    $uj_H=0;
    foreach($s as $key=>$val)
    { $_b = imageTTFBbox($fsize,  0,  getcwd().$font,   $val);
      $_W = abs($_b[2]-$_b[0]);
      //X koordináta
      $_X = $W-$_W;
      //Y koordináta
      $_H = abs($_b[5]-$_b[3]); 
      $uj_H += $_H;             
      imageTTFText($im, $fsize, $angle, $_X, $uj_H, $text_color, getcwd().$font, $val);   
      if ($shadow)
      { imageTTFText($im, $fsize, $angle, $_X+1, $uj_H+1, $shadow_color, getcwd().$font, $val); }      
      $uj_H += $lead;
    }
  }elseif($L_R_C == 2)
  { //Igazítás középre
    $uj_H=0;
    foreach($s as $key=>$val)
    { $_b = imageTTFBbox($fsize,0,getcwd().$font,$val);
      $_W = abs($_b[2]-$_b[0]);
      //X koordináta
      $_X = abs($W/2)-abs($_W/2);
      //Y koordináta
      $_H = abs($_b[5]-$_b[3]); 
      $uj_H += $_H;             
      imageTTFText($im, $fsize, $angle, $_X, $uj_H, $text_color, getcwd().$font, $val);   
      if ($shadow)
      { imageTTFText($im, $fsize, $angle, $_X+1, $uj_H+1, $shadow_color, getcwd().$font, $val); }      
      $uj_H += $lead;
    }
  }
  //END KÉP LÉTREHOZÁSA       
  return $im;
}
?>
